import pandas as pd
import numpy as np
import csv
import sys

# This file should be run in the output folder, not within each job folder
# Arguments:
#   sys.argv[1]  -  project's base folder where the project files, including 
#                   the reference data file, are located
#   sys.argv[2]  -  output folder of the project where job folders are located
#   sys.argv[3]  –  the list of the job IDs of the simulations that have been executed
#   sys.argv[4]  -  user-defined output table name + .csv
#   sys.argv[5]  -  Other arguments specified in the RVX file, in this case, 
#                   the input table file name without extension, followed by 
#                   the reference data file name. ("HourlyMeters;ref_jess.csv")

# Ackley's single objective test problem two objectivefunction which calculates the ANN model
# input - x, y in [-5, 5]
# output - Ackley's function f(x,y)
def ackleys_function(x, y):
	output = -20 * math.exp(-0.2 * math.sqrt((x*x + y*y)/2)) - math.exp(0.5 * (math.cos(2*math.pi*x) + math.cos(2*math.pi*y))) + math.e + 20
	return output
	
# Sphere function test problem
# input - x0...xn in [-5, 5]
# output - Sphere function Sigma(xi^2)
def sphere_function(input):
	sum = 0
	for x in input:
		sum = sum + x*x
	return sum
	
# Linear function test problem
# input - x0...xn in [-5, 5]
# output - The sum of xis
def linear_function(input):
	output = np.sum(input)
	return output
	
# This script takes 
args = sys.argv[5].split(';')

# Read data from the job list file (csv format) in the output folder	
indata = pd.read_csv(sys.argv[2] + args[0], header=None, index_col=0) 

# Record size of job matrix
rowcolno = indata.shape

# Header row of the output need to be determined and hard-coded in here
heading = ["#", "Job_ID", "Reserved", "f1", "f2"]

# output file name from the parameter passed to the script
outname = sys.argv[4] 

with open(outname, "w", newline='') as outfile:
	output=csv.writer(outfile)
	output.writerow(heading)
	for i in indata.index:
		resultrow = [0, i, 'AAA']
		resultrow.append(sphere_function(indata.ix[i]))
		resultrow.append(linear_function(indata.ix[i]))
		output.writerow(resultrow)
